//	ipaddress.cpp
#include <iostream>
#include <ostream>
#include <string>
#include <stdlib.h>
#include "ipaddress.h"

using namespace std;

IpAddress::IpAddress()
{
}

IpAddress::IpAddress( int a, int b, int c, int d)
{
	if( !setVal( a, b, c, d))	setVal( 0, 0, 0, 0);
}

IpAddress::IpAddress( string *str)
{
	if( !setVal( str))	setVal( 0, 0, 0, 0);
}

IpAddress::IpAddress( char* cstr)
{
	if( !setVal( cstr))	setVal( 0, 0, 0, 0);
}

IpAddress::IpAddress( IpAddress* ip)
{
	setVal( ip);
}

bool IpAddress::setVal( int a, int b, int c, int d)
{
	b0 = a; b1 = b; b2 = c; b3 = d;
	return initString();
}

bool IpAddress::setVal( IpAddress* ip)
{
	b0 = ip->getB( 0); b1 = ip->getB( 1);
	b2 = ip->getB( 2); b3 = ip->getB( 3);
	return initString();
}

bool IpAddress::setVal( string *str)
{
	return s2ip( str, this);
}

bool IpAddress::setVal( char *cstr)
{
	return s2ip( &string(cstr), this);
}

bool IpAddress::setVal( int n, int x)
{
	switch(n)
	{
	case 0 : b0 = x; break;
	case 1 : b1 = x; break;
	case 2 : b2 = x; break;
	case 3 : b3 = x; break;
	default: break;
	}
	return initString();
}

string* IpAddress::getString()
{
	return &strThis;
}


int IpAddress::getB( int n){
	switch( n){
	case 0:	return b0;
	case 1:	return b1;
	case 2:	return b2;
	case 3:	return b3;
	default : return -1;
	}
}

bool IpAddress::initString()
{
	return ip2s( this, &strThis);
}

bool IpAddress::ip2s( IpAddress *ip, string *str)
{
	char buf[4];
	int temp;
	string strWork;
	for( int i = 0; i < 4; i++)
	{
		temp = ip->getB(i);
		if( temp < 0 || 255 < temp)	return false;
		_itoa( temp, buf, 10);
		strWork += string( buf);
		strWork += ".";
	}
	strWork.erase( strWork.end()-1);
	*str = strWork;
	return true;
}

bool IpAddress::s2ip( string *str, IpAddress *ip)
{
	char buf[4];
	int b[4];
	int a[4];// for bug.
	int l, n, i, temp;
	l = str->size();
	i = 0;
	//	check if str length is correct
	if( l < 7 || 16 < l)	return false;
	//	...l...n...
	while( l > 0)
	{
		buf[0] = '\0';
		//	too much period
		if( i >3)	return false;
		n = l;
		l = str->rfind( '.', l-1);//serach next to .
		temp = str->copy( buf, n-l+1,l+1);
		buf[temp] = '\0';
		temp = atoi( buf);
		if( temp < 0 || 255 < temp)	return false;
		//	a[i] should not be here. But there was something wrong
		//	using a[] solbe this problem. I think it's bug of compiler
		a[i] = b[i] = temp;
		i++;
	}
	ip->setVal( b[3], b[2], b[1], a[0]);
	return true;
}

IpAddress::~IpAddress()
{}

IpCollecter::IpCollecter()
{
	smallest = greatest = NULL;
}

bool IpCollecter::collect( IpAddress* pNew)
{
	//IpNode* pGreater;
	IpNode* pTemp = greatest;
	IpNode* pTempSave;
	if( greatest == NULL)
	{
		greatest = smallest = pTemp = new IpNode( pNew);
		return true;
	}
	while( pTemp != NULL)
	{
		//	!(pTemp<=pNew);pNew < pTemp
		if( aIsSmall( pNew, (IpAddress*)pTemp)){
			//cout << pNew->getString()->data()
			//	 << "<"<< pTemp->getString()->data() << endl;
			pTemp = pTemp->pIpForward;
		}
		//	pNew == pTemp
		else if( twoAreSame( pTemp, pNew))
			return false;
		//	pTemp < pNew
		else
			break;
	}
	if( pTemp == NULL)//	most front
	{
		pTemp = new IpNode( pNew);
		pTemp->pIpBackward = smallest;
		smallest->pIpForward=pTemp;
		smallest = pTemp;
	}
	else
	{
		pTempSave = pTemp;
		pTemp = new IpNode( pNew);
		pTemp->pIpForward = pTempSave;
		pTemp->pIpBackward = pTempSave->pIpBackward;
		pTempSave->pIpBackward = pTemp;
		if( pTemp->pIpBackward != NULL)
			pTemp->pIpBackward->pIpForward = pTemp;
	}
	//	if greatest is smaller than pTemp
	if( aIsSmall( greatest, pTemp))
		greatest = pTemp;
	return true;
}

//	if pIpA < pIpB, return true
bool IpCollecter::aIsSmall( IpAddress* pIpA, IpAddress* pIpB)
{
	for( int i = 0; i < 4; i++)
	{
		if( pIpA->getB(i) < pIpB->getB(i))
			return true;
		else if(pIpA->getB(i) > pIpB->getB(i))
			return false;
		else
			continue;
	}
	return false;
}

bool IpCollecter::twoAreSame( IpAddress* pIpA, IpAddress* pIpB)
{
	if(	pIpA->getB(0) == pIpB->getB(0) && pIpA->getB(1) == pIpB->getB(1)
	  &&pIpA->getB(2) == pIpB->getB(2) && pIpA->getB(3) == pIpB->getB(3))
		return true;
	return false;
}
	
IpAddress* IpCollecter::greater( IpAddress* pA, IpAddress* pB)
{
	for( int i = 0; i < 4; i++)
	{
		if( pA->getB(i) < pB->getB(i))
			return pB;
		else if( pA->getB(i) > pB->getB(i))
			return pA;
	}
	return NULL;
}

IpAddress* IpCollecter::smaller( IpAddress* pA, IpAddress* pB)
{
	if( twoAreSame( pA, pB))				return NULL;
	if( twoAreSame(greater( pA, pB), pB))	return pA;
	else									return pB;
}

void IpCollecter::show( ostream *os)
{
	IpNode* pNd = smallest;
	while( pNd != NULL)
	{
		*os << "IpCollecter " << *(pNd->getString()) << endl;
		pNd = pNd->pIpBackward;
	}
}

IpCollecter::~IpCollecter()
{
	IpNode* pNd = smallest;
	IpNode* pNd2;
	while( pNd != NULL)
	{
		pNd2 = pNd->pIpBackward;
		delete pNd;
		pNd = pNd2;
	}
}

IpNode::IpNode( IpAddress* pNew)
:	IpAddress( pNew)
{
	pIpForward = pIpBackward = NULL;
	//delete pNew;
//	b0 = pNew->getB(0); b1 = pNew->getB(1);
//	b2 = pNew->getB(2); b3 = pNew->getB(3);
	delete pNew;
}

