//	ipaddress.h

#ifndef IPADDRESS_H
#define IPADDRESS_H

#include <string>
#include <ostream>

using namespace std;

class IpAddress
{
public:
	IpAddress();
	IpAddress( int a, int b, int c, int d);
	IpAddress( IpAddress* ip);
	IpAddress( string* str);
	IpAddress( char* cstr);
	~IpAddress();
	int getB( int n);
	string* getString();
	bool setVal( int a, int b, int c, int d);
	bool setVal( IpAddress* ip);
	bool setVal( string* str);
	bool setVal( char *cstr);
	bool setVal( int n, int x);
protected:
	int b0, b1, b2, b3;
private:
	string strThis;
	bool initString();
	bool ip2s( IpAddress *ip, string *str);
	bool s2ip( string *str, IpAddress *ip);
};

class IpNode : public IpAddress
{
public:
	IpNode( IpAddress* pNew);
	// pIpForward < pIpBackward
	IpNode* pIpForward;
	IpNode* pIpBackward;
};

class IpCollecter
{
public:
	IpCollecter();
	~IpCollecter();
	bool collect( IpAddress* pNew);
	void show( ostream *os);
	//	if pIpA < pIpB, return true
	bool aIsSmall( IpAddress* pIpA, IpAddress* pIpB);
	bool twoAreSame( IpAddress* pIpA, IpAddress* pIpB);
	IpAddress* greater( IpAddress* pA, IpAddress* pB);
	IpAddress* smaller( IpAddress* pA, IpAddress* pB);
private:
	IpNode* smallest;
	IpNode* greatest;
};


#endif	IPADDRESS_H