//	monoata.cpp

#include <iostream>
#include <string>
#include <windows.h>
#include <conio.h>
#include <process.h>
#include "kenshiro.h"
#include "louncher.h"

using namespace std;

Kenshiro::Kenshiro(){}

Kenshiro::Kenshiro( char *str)
:	lpSound(NULL),	pError(NULL)
{
	init( &string(str));
}

Kenshiro::Kenshiro( string* pstr)
:	lpSound(NULL),	pError(NULL)
{
	init( pstr);
}

void Kenshiro::init( string *pstr)
{
	//	File open
	HANDLE fh = CreateFile(
			pstr->data(),
			GENERIC_READ,
			0,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			NULL);
	if( fh == INVALID_HANDLE_VALUE)	
	{
		pError = new Error( "file can't be opened");
	}
	//	Reserve buffer
	lpSound=GlobalAlloc( GPTR, GetFileSize( fh, NULL));
	if( lpSound == NULL)
	{
		pError = new Error( "GlobalAlloc() failure");
	}
	//	Read file
	if( 0 == ReadFile( fh, lpSound, GetFileSize( fh, NULL), &dummy, NULL))
	{
		GlobalFree( lpSound);
		CloseHandle(fh);
		pError = new Error( "ReadFile() failure");
	}
	CloseHandle(fh);
}

void Kenshiro::play()
{
	if( lpSound != NULL)
	{
		if( PlaySound((char*)lpSound, NULL, SND_SYNC|SND_MEMORY|SND_NOWAIT))
		{
			//cout << "playing..." << endl;
			//PlaySound( NULL, NULL, SND_SYNC);
		}
	}
}

Kenshiro::~Kenshiro()
{
	if( pError	!= NULL)		delete pError;
}

