//	louncher.cpp

#include <ostream>
#include <iostream>
#include <string>
#include <windows.h>
#include <process.h>
#include <winsock.h>
#include "louncher.h"
#include "ipaddress.h"
#include "kenshiro.h"

using namespace std;

Louncher::Louncher(){}

Louncher::Louncher( IpAddress* pStart, IpAddress* pEnd, ostream *ofstr, int md)
{
	int nRet;
	os			 = ofstr;
	pIpStart	 = pStart;
	pIpCurrent	 = pIpStart;
	pIpEnd		 = pEnd;
	nVoiceNo	 = 0;
	ataNo		 = hitNo = 0;
	lsningpermit = false;
	balletsempty = false;
	destroypermit= false;
	mode		 = md;

	if( mode == MODE_SOUND)
	{
		//	Sound Object
		pKenA_	= new Kenshiro( "a_.wav");
		pKenTa	= new Kenshiro( "ta.wav");
		pKenTah	= new Kenshiro( "tah.wav");
	}
 	// Check version
    wVersionRequested	= MAKEWORD(1,1);
	nRet				= WSAStartup(wVersionRequested, &wsaData);

    if(nRet)
		throw new Error( "Winsock Initialize");
    if(wsaData.wVersion != wVersionRequested)
		throw new Error( "Winsock Version");
	// Create a Raw socket
	rawSocket = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);
	
	if(rawSocket == SOCKET_ERROR) 	ReportError("socket()");
}

bool Louncher::areBalletsEmpty(){return balletsempty;}
bool Louncher::ready2Death()	{return destroypermit;}
int Louncher::getHit()	{	return hitNo;}
int Louncher::getAtaNo(){	return ataNo;}

void Louncher::fire()
{
	//pKenA_->play();
	_beginthread( a_tah,	0, (void*)this);
	if( mode == MODE_SOUND)
		_beginthread( soundLoop,0, (void*)this);
	//	Wait for a_tah does finish first loop
	while( !lsningpermit){}
	_beginthread( listner,	0, (void*)this);
}

void Louncher::listner( void *myclass)
{
	Louncher &lnch = *((Louncher*)myclass);
	struct sockaddr_in saSrc;
	unsigned char cTTL;
	int nRet;
	while( true)
	{
		//	if atah thread've finished
		if( lnch.areBalletsEmpty())
		{
			static const DWORD countstart= GetTickCount();
			lnch.nVoiceNo = 2;	// play Tah!
			if( GetTickCount() - countstart > 2000L)
			{
				if( lnch.mode == MODE_NOSOUND)
				{
					lnch.destroypermit = true;
					break;
				}
			}
		}
		nRet = lnch.WaitForEchoReply( lnch.rawSocket);
		if (nRet == SOCKET_ERROR)
		{
			lnch.ReportError("select()");
		}
		if (!nRet)
		{
			//*( lnch.os) << "Time Out" << endl;
		}
		else
		{
			// Receive reply
			lnch.RecvEchoReply( lnch.rawSocket, &saSrc, &cTTL);
			//cout << inet_ntoa(saSrc.sin_addr) << endl;
			//*(lnch.os) << inet_ntoa(saSrc.sin_addr) << endl;
			if( lnch.collecter.collect(
					new IpAddress( inet_ntoa( saSrc.sin_addr))
				))
			{
				lnch.hitNo++;
				//cout << "hit!" << endl;
			}

		}
	}
}

//	Caution! this function required to delete
//	return value!
IpAddress* Louncher::getNextAddress()
{
	//	I am virgin
	if( ataNo == 0)
	{
		ataNo++;
		return pIpCurrent;
	}
	else
	{
		//	Inclement IP Address pIpCurrent
		pIpCurrent->setVal( 3, pIpCurrent->getB(3)+1);
		if( pIpCurrent->getB(3) == 256)
		{
			for( int i = 3; i > 0; i--)
			{
				if( pIpCurrent->getB(i) == 256)
				{
					pIpCurrent->setVal(i, 0);
					pIpCurrent->setVal(i-1, pIpCurrent->getB(i-1)+1);
				}
			}
			if( pIpCurrent->getB(0) == 256)
				return NULL;
		}
	}
	if(	  collecter.aIsSmall( pIpCurrent, pIpEnd)
		||collecter.twoAreSame( pIpCurrent, pIpEnd) )
	{
		ataNo++;
		return pIpCurrent;
	}
	else
	{
		return NULL;
	}
}

void Louncher::a_tah( void *myclass)
{
	Louncher &lnch = *((Louncher*)myclass);
	IpAddress* target;
	unsigned int addr;
	struct    sockaddr_in saDest;
	LPHOSTENT lpHost;
	
	//lnch.nVoiceNo = 1;	// sound Ta
	while( true)
	{
		target = lnch.getNextAddress();
		if( target == NULL)
		{
			lnch.balletsempty = true;
			return;
		}
		addr = inet_addr( target->getString()->data());
		if( addr == INADDR_NONE)
		{
			//	Lookup host
			lpHost = gethostbyname( target->getString()->data());
			if( !lpHost)
			{
				throw new Error(
					string( "Unable to resolve Host :")
					+ *(target->getString())
				);
			}
			memcpy(&(saDest.sin_addr),lpHost->h_addr,lpHost->h_length);
			saDest.sin_family = lpHost->h_addrtype;
		}
		else
		{
			saDest.sin_addr.s_addr = addr;
		}
		saDest.sin_family = AF_INET;
		saDest.sin_port = 0;
		// Send ICMP echo request
		lnch.SendEchoRequest( lnch.rawSocket, &saDest);
		if(!lnch.lsningpermit)	lnch.lsningpermit = true;
		Sleep( 10L);
	}
}

void Louncher::soundLoop( void* myclass)
{
	int* voiceno = &(((Louncher*)myclass)->nVoiceNo);
	while( *voiceno != -1)
	{
		switch( *voiceno)
		{
		//	Say "A_ta" and set next voice "Ta"
		case 0	: ((Louncher*)myclass)->pKenA_->play();
				  // next voice should be "ta"
				  *voiceno = 1;
				  continue;
		//	Say "Ta"
		case 1	: ((Louncher*)myclass)->pKenTa->play();
				  continue;
		//	Say "Tah_" and end
		case 2	: ((Louncher*)myclass)->pKenTah->play();
				  // next is nothing, goto case -1 to finish
				  *voiceno = -1;
				  break;
		//	Emergency end
		default : *voiceno = -1;
		}
	}
	((Louncher*)myclass)->destroypermit = true;
}

Louncher::~Louncher()
{
	collecter.show( os);
	int nRet = closesocket(rawSocket);
	if (nRet == SOCKET_ERROR)
	{
		// Free WinSock
		WSACleanup();
		ReportError("closesocket()");
		return;
	}
	else {
		// Free WinSock
		WSACleanup();
	}
}

Error::Error()
{
	message = "Error : Unknown";
}

Error::Error( string *pstrEmsg)
{
	message = string("Error : ") + string( *pstrEmsg);
}

Error::Error( string strEmsg)
{
	message = strEmsg;
}

Error::Error( char *cstr)
{
	message = string("Error : ") + string( cstr);
}

string* Error::getMessage()
{
	return &message;
}
//	-------------------------No touch----------------------

// SendEchoRequest()
// Fill in echo request header
// and send to destination
int Louncher::SendEchoRequest(SOCKET s,LPSOCKADDR_IN lpstToAddr) 
{
	static ECHOREQUEST echoReq;
	static nId = 1;
	static nSeq = 1;
	int nRet;

	// Fill in echo request
	echoReq.icmpHdr.Type		= ICMP_ECHOREQ;
	echoReq.icmpHdr.Code		= 0;
	echoReq.icmpHdr.Checksum	= 0;
	echoReq.icmpHdr.ID			= nId++;
	echoReq.icmpHdr.Seq			= nSeq++;

	// Fill in some data to send
	for (nRet = 0; nRet < REQ_DATASIZE; nRet++)
		echoReq.cData[nRet] = ' '+nRet;

	// Save tick count when sent
	echoReq.dwTime				= GetTickCount();

	// Put data in packet and compute checksum
	echoReq.icmpHdr.Checksum = in_cksum((u_short *)&echoReq, sizeof(ECHOREQUEST));

	// Send the echo request  								  
	nRet = sendto(s,						/* socket */
				 (LPSTR)&echoReq,			/* buffer */
				 sizeof(ECHOREQUEST),
				 0,							/* flags */
				 (LPSOCKADDR)lpstToAddr, /* destination */
				 sizeof(SOCKADDR_IN));   /* address length */

	if (nRet == SOCKET_ERROR) 
		ReportError("sendto()");
	return (nRet);
}


// RecvEchoReply()
// Receive incoming data
// and parse out fields
DWORD Louncher::RecvEchoReply(SOCKET s, LPSOCKADDR_IN lpsaFrom, u_char *pTTL) 
{
	ECHOREPLY echoReply;
	int nRet;
	int nAddrLen = sizeof(struct sockaddr_in);

	// Receive the echo reply	
	nRet = recvfrom(s,					// socket
					(LPSTR)&echoReply,	// buffer
					sizeof(ECHOREPLY),	// size of buffer
					0,					// flags
					(LPSOCKADDR)lpsaFrom,	// From address
					&nAddrLen);			// pointer to address len

	// Check return value
	if (nRet == SOCKET_ERROR) 
		ReportError("recvfrom()");

	// return time sent and IP TTL
	*pTTL = echoReply.ipHdr.TTL;
	return(echoReply.echoRequest.dwTime);   		
}

// What happened?
void Louncher::ReportError(LPCSTR pWhere)
{
	throw new Error( "Windows Socket Operation Failed");
}


// WaitForEchoReply()
// Use select() to determine when
// data is waiting to be read
int Louncher::WaitForEchoReply(SOCKET s)
{
	struct timeval Timeout;
	fd_set readfds;

	readfds.fd_count = 1;
	readfds.fd_array[0] = s;
	Timeout.tv_sec = 1;
    Timeout.tv_usec = 0;

	return(select(1, &readfds, NULL, NULL, &Timeout));
}


//
// Mike Muuss' in_cksum() function
// and his comments from the original
// ping program
//
// * Author -
// *	Mike Muuss
// *	U. S. Army Ballistic Research Laboratory
// *	December, 1983

/*
 *			I N _ C K S U M
 *
 * Checksum routine for Internet Protocol family headers (C Version)
 *
 */
u_short Louncher::in_cksum(u_short *addr, int len)
{
	register int nleft = len;
	register u_short *w = addr;
	register u_short answer;
	register int sum = 0;

	/*
	 *  Our algorithm is simple, using a 32 bit accumulator (sum),
	 *  we add sequential 16 bit words to it, and at the end, fold
	 *  back all the carry bits from the top 16 bits into the lower
	 *  16 bits.
	 */
	while( nleft > 1 )  {
		sum += *w++;
		nleft -= 2;
	}

	/* mop up an odd byte, if necessary */
	if( nleft == 1 ) {
		u_short	u = 0;

		*(u_char *)(&u) = *(u_char *)w ;
		sum += u;
	}

	/*
	 * add back carry outs from top 16 bits to low 16 bits
	 */
	sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
	sum += (sum >> 16);			/* add carry */
	answer = ~sum;				/* truncate to 16 bits */
	return (answer);
}

