//	louncher.h

#ifndef	LOUNCHER_H
#define	LOUNCHER_H

#include <ostream>
#include <string>
#include <winsock.h>
#include "ipaddress.h"
#include "kenshiro.h"

#define MODE_NOSOUND	0
#define MODE_SOUND		1

#define ICMP_ECHOREPLY	0
#define ICMP_ECHOREQ	8
#define REQ_DATASIZE 32		// Echo Request Data size

using namespace std;

class Louncher
{
public:
	Louncher();
	Louncher( IpAddress* pStart, IpAddress* pEnd, ostream* ofstr, int md);
	bool	areBalletsEmpty();
	bool	ready2Death();
	void	fire();
	int		getHit();
	int		getAtaNo();
	~Louncher();
#ifdef DEBUGMODE 
#else
private:
#endif
	bool		lsningpermit, destroypermit;
	bool		balletsempty;
	IpAddress	*pIpStart, *pIpEnd, *pIpCurrent;
	int			nVoiceNo, ataNo, hitNo;
	SOCKET		rawSocket;
	WSADATA		wsaData;
    WORD		wVersionRequested;
	ostream		*os;
	Kenshiro	*pKenA_, *pKenTa, *pKenTah;
	IpCollecter collecter;
	int			mode;
	IpAddress*	getNextAddress();
	static void listner( void* myclass);
	static void a_tah( void* myclass);
	static void soundLoop( void* myclass);
	// IP Header -- RFC 791
	typedef struct tagIPHDR
	{
		u_char  VIHL;			// Version and IHL
		u_char	TOS;			// Type Of Service
		short	TotLen;			// Total Length
		short	ID;				// Identification
		short	FlagOff;		// Flags and Fragment Offset
		u_char	TTL;			// Time To Live
		u_char	Protocol;		// Protocol
		u_short	Checksum;		// Checksum
		struct	in_addr iaSrc;	// Internet Address - Source
		struct	in_addr iaDst;	// Internet Address - Destination
	}IPHDR, *PIPHDR;
	
	
	// ICMP Header - RFC 792
	typedef struct tagICMPHDR
	{
		u_char	Type;			// Type
		u_char	Code;			// Code
		u_short	Checksum;		// Checksum
		u_short	ID;				// Identification
		u_short	Seq;			// Sequence
		char	Data;			// Data
	}ICMPHDR, *PICMPHDR;
	
	// ICMP Echo Request
	typedef struct tagECHOREQUEST
	{
		ICMPHDR icmpHdr;
		DWORD	dwTime;
		char	cData[REQ_DATASIZE];
	}ECHOREQUEST, *PECHOREQUEST;
	typedef struct tagECHOREPLY
	{
		IPHDR	ipHdr;
		ECHOREQUEST	echoRequest;
		char    cFiller[256];
	}ECHOREPLY, *PECHOREPLY;

	// Internal Functions
	void ReportError(LPCSTR pstrFrom);
	int  WaitForEchoReply(SOCKET s);
	u_short in_cksum(u_short *addr, int len);
	
	// ICMP Echo Request/Reply functions
	int		SendEchoRequest(SOCKET, LPSOCKADDR_IN);
	DWORD	RecvEchoReply(SOCKET, LPSOCKADDR_IN, u_char *);
	};

class Error
{
public:
	Error();
	Error( string* pstrEMsg);
	Error( string strEmsg);
	Error( char *);
	string* getMessage();
private:
	string message;
};

#endif	LOUNCHER_H
