//	main.cpp
#pragma comment( lib, "wsock32.lib")
#pragma comment( lib, "winmm.lib")

#define WIN32_LEAN_AND_MEAN

#include <iostream>
#include <fstream>
#include <conio.h>
#include <process.h>
#include "louncher.h"
using namespace std;

void useage()
{
	cout << "please give parameters" << endl;
	cout << "necessary : -from [IP Address] -to [IP Address]" << endl;
	cout << "option    : -savefile [filename]" << endl;
	cout << "            -nosound" << endl;
}

int main( int argv, char** argc)
{
	HANDLE hStdOut;         /* R\[ EBhẼnh*/
	CONSOLE_SCREEN_BUFFER_INFO csbi;    /* R\[\*/
	COORD	coordinate;
	DWORD	result;
	int		mode = MODE_SOUND;
	coordinate.X = 6;
	coordinate.Y = (int)(3);

	
	Louncher *pLounch = NULL;
	
	
	//	---------------------------------------------------
	//				Compute Parameter
	//	---------------------------------------------------
	IpAddress	ipfrom, ipto, *piptemp;
	string*		pstrFilename = NULL;
	bool		flgFrom, flgTo;
	flgFrom = flgTo = false;
	int i;
	//	No Parameter
	if( argv < 2)
	{
		useage();
		return 1;
	}
	//	Parameter not enough
	if( argv < 5)
	{
		useage();
		return 1;
	}
	//	Get information from parameter
	for( i = 1; i < argv; i++)
	{
		if( string( argc[i]).compare( "-from") == 0)
		{
			cout << "-from" << endl;
			if( ipfrom.setVal( argc[++i]))
			{
			}
			else
			{
				cout << "Invalid IP Address : " << argc[i] << endl;
				flgFrom = true;
				return 1;
			}
		}
		else if( string( argc[i]).compare( "-to") == 0)
		{
			i=i+1;
			if( ipto.setVal( argc[i]))
			{
				flgTo = true;
			}
			else
			{
				cout << "Invalid IP Address : " << argc[i] << endl;
				return 1;
			}
		}
		else if( string( argc[i]).compare( "-savefile") == 0)
		{
			i++;
			if( i < argv)
			{
				pstrFilename = new string( argc[i]);
			}
		}
		else if( string( argc[i]).compare( "-nosound") == 0)
		{
			mode = MODE_NOSOUND;
		}
		else
		{
			cout << "Invalid Parameter : " << argc[i] << endl;
			return -1;
		}
	}
	if( flgTo&&flgFrom)
	{
		cout << "parameter -from and -to are required" << endl;
		if( pstrFilename != NULL)	delete pstrFilename;
		return 1;
	}

	//	Check pipform < pipto
	IpCollecter *ipc = new IpCollecter();
	piptemp = ipc->greater( &ipfrom, &ipto);
	if( piptemp != NULL)
	{
		ipfrom = *ipc->smaller( &ipfrom, &ipto);
		ipto   = *piptemp;
	}
	delete ipc;

	if( pstrFilename == NULL)
		pstrFilename =
			new string(
				*ipfrom.getString()
				+ string("to")
				+ *ipto.getString()
				+ string(".txt"));
	//	File open
	ofstream output( pstrFilename->data(), ios::trunc);
	if( output.fail()) {
		cout << "file can't be opened" << endl;
		delete pstrFilename;
		return 1;
	}
	//	initialization of output
    hStdOut = GetStdHandle( STD_OUTPUT_HANDLE );
	/* ʂ̃eLXgƍs̏擾܂B */
	GetConsoleScreenBufferInfo( hStdOut, &csbi );
 /*
	DWORD    dummy;
    COORD    Home = { 0, 0 };
    FillConsoleOutputCharacter(
		hStdOut, ' ', csbi.dwSize.X * csbi.dwSize.Y, Home, &dummy
		);
*/
	cout << "Pinging... from " << *ipfrom.getString()
		 << " to " << *ipto.getString() << endl;
	cout << "Output filename : " << *pstrFilename << endl;
	//	Program core boot
	try
	{
		pLounch = new Louncher( &ipfrom, &ipto, &output, mode);
		pLounch->fire();
	}
	catch( Error *pError)
	{
		cout << *(pError->getMessage()) << endl;
		delete pError;
		if( pLounch != NULL)	delete pLounch;
		output.close();
		delete pstrFilename;
		return 1;
	}
	int hit, oldhit;
	oldhit = 0;
	char itoaed[10];
	cout << "Hit : ";
	while( !pLounch->ready2Death())
	{
		hit = pLounch->getHit();
		if( hit > oldhit)
		{
			_itoa( hit, itoaed, 10);
			WriteConsoleOutputCharacter(
				hStdOut, itoaed, strlen(itoaed), coordinate, &result
			);
			oldhit = hit;
		}
	}
	cout << hit << endl;
	delete pstrFilename;
	delete pLounch;
	output.close();
	CloseHandle( hStdOut);
	return 0;
}

